-- Retro Skincolors - 2.0 Skincolors

freeslot(
	"SKINCOLOR_20CYAN",
	"SKINCOLOR_20PEACH",
	"SKINCOLOR_20LAVENDER",
	"SKINCOLOR_20SILVER",
	"SKINCOLOR_20ORANGE",
	"SKINCOLOR_20RED",
	"SKINCOLOR_20BLUE",
	"SKINCOLOR_20STEELBLUE",
	"SKINCOLOR_20PINK",
	"SKINCOLOR_20BEIGE",
	"SKINCOLOR_20PURPLE",
--	"SKINCOLOR_20GREEN", -- Basically the same as 2.2's Green
	"SKINCOLOR_20WHITE",
	"SKINCOLOR_20GOLD", -- Same as FD Gold
	"SKINCOLOR_20YELLOW", -- Same as FD Yellow
	"SKINCOLOR_SUPER20YELLOW1",
	"SKINCOLOR_SUPER20YELLOW2",
	"SKINCOLOR_SUPER20YELLOW3",
	"SKINCOLOR_SUPER20YELLOW4",
	"SKINCOLOR_SUPER20YELLOW5"
)

skincolors[SKINCOLOR_20CYAN] = {
	name = "ME_Cyan",
	ramp = {128,128,129,129,130,131,132,133,134,135,136,137,141,142,143,138},
	invcolor = SKINCOLOR_SANDY,
	invshade = 1,
	chatcolor = V_SKYMAP,
	accessible = true
}

skincolors[SKINCOLOR_20PEACH] = {
	name = "ME_Peach",
	ramp = {208,208,48,216,216,217,217,218,218,219,220,221,221,222,223,223},
	invcolor = SKINCOLOR_RUST,
	invshade = 7,
	chatcolor = V_ROSYMAP,
	accessible = true
}

skincolors[SKINCOLOR_20LAVENDER] = {
	name = "ME_Lavender",
	ramp = {192,192,193,193,194,194,195,195,196,196,197,197,198,198,199,199},
	invcolor = SKINCOLOR_20GOLD,
	invshade = 4,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

skincolors[SKINCOLOR_20SILVER] = {
	name = "ME_Silver",
	ramp = {1,2,3,3,4,5,6,7,8,9,10,11,12,13,14,15},
	invcolor = SKINCOLOR_GREY,
	invshade = 12,
	chatcolor = V_GREYMAP,
	accessible = true
}

skincolors[SKINCOLOR_20ORANGE] = {
	name = "ME_Orange",
	ramp = {208,48,49,50,51,52,53,54,55,55,56,57,58,59,60,60},
	invcolor = SKINCOLOR_20BLUE,
	invshade = 7,
	chatcolor = V_ORANGEMAP,
	accessible = true
}

skincolors[SKINCOLOR_20RED] = {
	name = "ME_Red",
	ramp = {33,34,35,35,36,37,38,39,40,41,42,43,44,45,71,46},
	invcolor = SKINCOLOR_GREEN,
	invshade = 10,
	chatcolor = V_REDMAP,
	accessible = true
}

skincolors[SKINCOLOR_20BLUE] = {
	name = "ME_Blue",
	ramp = {144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159},
	invcolor = SKINCOLOR_20ORANGE,
	invshade = 7,
	chatcolor = V_BLUEMAP,
	accessible = true
}

skincolors[SKINCOLOR_20STEELBLUE] = {
	name = "ME_Steel_Blue",
	ramp = {144,144,145,145,170,170,171,171,172,172,173,173,174,174,199,199},
	invcolor = SKINCOLOR_20PINK,
	invshade = 5,
	chatcolor = V_AZUREMAP,
	accessible = true
}

skincolors[SKINCOLOR_20PINK] = {
	name = "ME_Pink",
	ramp = {209,209,210,210,211,211,211,211,212,212,213,213,214,214,215,215},
	invcolor = SKINCOLOR_20STEELBLUE,
	invshade = 9,
	chatcolor = V_ROSYMAP,
	accessible = true
}

skincolors[SKINCOLOR_20BEIGE] = {
	name = "ME_Beige",
	ramp = {240,240,241,242,242,243,243,244,245,246,247,248,249,250,251,237},
	invcolor = SKINCOLOR_MOSS,
	invshade = 5,
	chatcolor = V_BROWNMAP,
	accessible = true
}

skincolors[SKINCOLOR_20PURPLE] = {
	name = "ME_Purple",
	ramp = {179,179,181,181,182,182,183,183,184,184,185,185,186,186,187,187},
	invcolor = SKINCOLOR_LIME,
	invshade = 6,
	chatcolor = V_MAGENTAMAP,
	accessible = true
}

skincolors[SKINCOLOR_20WHITE] = {
	name = "ME_White",
	ramp = {1,1,2,2,3,3,3,3,4,4,5,5,6,6,7,7},
	invcolor = SKINCOLOR_BLACK,
	invshade = 5,
	chatcolor = 0,
	accessible = true
}

skincolors[SKINCOLOR_20GOLD] = {
	name = "ME_Gold",
	ramp = {83,83,64,64,65,65,66,66,67,67,68,68,69,69,70,70},
	invcolor = SKINCOLOR_20LAVENDER,
	invshade = 10,
	chatcolor = V_YELLOWMAP,
	accessible = true
}

skincolors[SKINCOLOR_20YELLOW] = {
	name = "ME_Yellow",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = true
}

skincolors[SKINCOLOR_SUPER20YELLOW1] = {
	name = "Super ME_Yellow 1",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER20YELLOW2] = {
	name = "Super ME_Yellow 2",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER20YELLOW3] = {
	name = "Super ME_Yellow 3",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER20YELLOW4] = {
	name = "Super ME_Yellow 4",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER20YELLOW5] = {
	name = "Super ME_Yellow 5",
	ramp = {80,81,82,83,72,72,73,73,64,64,65,66,66,66,67,68},
	invcolor = SKINCOLOR_CORNFLOWER,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}